// generated from rosidl_generator_c/resource/idl__description.c.em
// with input from nao_command_msgs:msg/RightEyeLeds.idl
// generated code does not contain a copyright notice

#include "nao_command_msgs/msg/detail/right_eye_leds__functions.h"

ROSIDL_GENERATOR_C_PUBLIC_nao_command_msgs
const rosidl_type_hash_t *
nao_command_msgs__msg__RightEyeLeds__get_type_hash(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static rosidl_type_hash_t hash = {1, {
      0xbb, 0xf2, 0x6a, 0x7b, 0x02, 0x73, 0x6e, 0x84,
      0xbe, 0x92, 0x42, 0x45, 0xfa, 0x3a, 0xfa, 0x7d,
      0x2d, 0x67, 0x96, 0x12, 0x78, 0x01, 0x49, 0xe4,
      0x37, 0xfe, 0xba, 0x68, 0x88, 0x69, 0x67, 0xc9,
    }};
  return &hash;
}

#include <assert.h>
#include <string.h>

// Include directives for referenced types
#include "std_msgs/msg/detail/color_rgba__functions.h"

// Hashes for external referenced types
#ifndef NDEBUG
static const rosidl_type_hash_t std_msgs__msg__ColorRGBA__EXPECTED_HASH = {1, {
    0x77, 0xa7, 0xa5, 0xb9, 0xae, 0x47, 0x73, 0x06,
    0x09, 0x76, 0x65, 0x10, 0x6e, 0x04, 0x13, 0xba,
    0x74, 0x44, 0x02, 0x45, 0xb1, 0xf3, 0xd0, 0xc6,
    0xd6, 0x40, 0x5f, 0xe5, 0xc7, 0x81, 0x3f, 0xe8,
  }};
#endif

static char nao_command_msgs__msg__RightEyeLeds__TYPE_NAME[] = "nao_command_msgs/msg/RightEyeLeds";
static char std_msgs__msg__ColorRGBA__TYPE_NAME[] = "std_msgs/msg/ColorRGBA";

// Define type names, field names, and default values
static char nao_command_msgs__msg__RightEyeLeds__FIELD_NAME__colors[] = "colors";

static rosidl_runtime_c__type_description__Field nao_command_msgs__msg__RightEyeLeds__FIELDS[] = {
  {
    {nao_command_msgs__msg__RightEyeLeds__FIELD_NAME__colors, 6, 6},
    {
      rosidl_runtime_c__type_description__FieldType__FIELD_TYPE_NESTED_TYPE_ARRAY,
      8,
      0,
      {std_msgs__msg__ColorRGBA__TYPE_NAME, 22, 22},
    },
    {NULL, 0, 0},
  },
};

static rosidl_runtime_c__type_description__IndividualTypeDescription nao_command_msgs__msg__RightEyeLeds__REFERENCED_TYPE_DESCRIPTIONS[] = {
  {
    {std_msgs__msg__ColorRGBA__TYPE_NAME, 22, 22},
    {NULL, 0, 0},
  },
};

const rosidl_runtime_c__type_description__TypeDescription *
nao_command_msgs__msg__RightEyeLeds__get_type_description(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static bool constructed = false;
  static const rosidl_runtime_c__type_description__TypeDescription description = {
    {
      {nao_command_msgs__msg__RightEyeLeds__TYPE_NAME, 33, 33},
      {nao_command_msgs__msg__RightEyeLeds__FIELDS, 1, 1},
    },
    {nao_command_msgs__msg__RightEyeLeds__REFERENCED_TYPE_DESCRIPTIONS, 1, 1},
  };
  if (!constructed) {
    assert(0 == memcmp(&std_msgs__msg__ColorRGBA__EXPECTED_HASH, std_msgs__msg__ColorRGBA__get_type_hash(NULL), sizeof(rosidl_type_hash_t)));
    description.referenced_type_descriptions.data[0].fields = std_msgs__msg__ColorRGBA__get_type_description(NULL)->type_description.fields;
    constructed = true;
  }
  return &description;
}

static char toplevel_type_raw_source[] =
  "# Message identifying colors for each RGB LED in the NAO's right eye.\n"
  "# Expect ranges for R, G and B are 0.0 - 1.0.\n"
  "# The alpha value (A) is ignored.\n"
  "\n"
  "# LED locations and their ids are shown below\n"
  "#                          _                         #\n"
  "#      /                  (_)                 \\\\      #\n"
  "#     /                                        \\\\     #\n"
  "#    /         R0                               \\\\    #\n"
  "#   |     R7  ____  R1              ____         |   #\n"
  "#   |        /    \\\\                /    \\\\        |   #\n"
  "#   |   R6  |  **  |  R2          |  **  |       |   #\n"
  "#   |        \\\\____/                \\\\____/        |   #\n"
  "#   |     R5        R3                           |   #\n"
  "#    \\\\         R4                               /    #\n"
  "#     \\\\                                        /     #\n"
  "#      \\\\                  ___                 /      #\n"
  "#       \\\\__               \\\\_/             __/        #\n"
  "#          \\\\__                         ___/          #\n"
  "#             \\\\_______________________/              #\n"
  "\n"
  "# For more details, refer to http://doc.aldebaran.com/2-1/family/robots/leds_robot.html#nao-v5-v4-and-v3-3\n"
  "\n"
  "int32 R0=0\n"
  "int32 R1=1\n"
  "int32 R2=2\n"
  "int32 R3=3\n"
  "int32 R4=4\n"
  "int32 R5=5\n"
  "int32 R6=6\n"
  "int32 R7=7\n"
  "int32 NUM_LEDS=8\n"
  "\n"
  "std_msgs/ColorRGBA[8] colors";

static char msg_encoding[] = "msg";

// Define all individual source functions

const rosidl_runtime_c__type_description__TypeSource *
nao_command_msgs__msg__RightEyeLeds__get_individual_type_description_source(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static const rosidl_runtime_c__type_description__TypeSource source = {
    {nao_command_msgs__msg__RightEyeLeds__TYPE_NAME, 33, 33},
    {msg_encoding, 3, 3},
    {toplevel_type_raw_source, 1265, 1265},
  };
  return &source;
}

const rosidl_runtime_c__type_description__TypeSource__Sequence *
nao_command_msgs__msg__RightEyeLeds__get_type_description_sources(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static rosidl_runtime_c__type_description__TypeSource sources[2];
  static const rosidl_runtime_c__type_description__TypeSource__Sequence source_sequence = {sources, 2, 2};
  static bool constructed = false;
  if (!constructed) {
    sources[0] = *nao_command_msgs__msg__RightEyeLeds__get_individual_type_description_source(NULL),
    sources[1] = *std_msgs__msg__ColorRGBA__get_individual_type_description_source(NULL);
    constructed = true;
  }
  return &source_sequence;
}
